all_maps = {"specimens": {"specimen_alteration": "alteration_grade", "specimen_alteration_type": "alteration_type", "er_analyst_mail_names": "analysts", "anisotropy_f": "aniso_f", "anisotropy_ff": "aniso_ff", "anisotropy_fl": "aniso_fl", "anisotropy_ftest": "aniso_ftest", "anisotropy_ftest12": "aniso_ftest12", "anisotropy_ftest23": "aniso_ftest23", "anisotropy_l": "aniso_l", "anisotropy_ll": "aniso_ll", "anisotropy_p": "aniso_p", "anisotropy_percent": "aniso_perc", "anisotropy_pp": "aniso_pp", "anisotropy_t": "aniso_t", "tilt_correction": "aniso_tilt_correction", "anisotropy_total": "aniso_total", "anisotropy_type": "aniso_type", "anisotropy_t1": "aniso_v1", "anisotropy_t2": "aniso_v2", "anisotropy_t3": "aniso_v3", "anisotropy_vg": "aniso_vg", "specimen_azimuth": "azimuth", "er_citation_names": "citations", "pmag_criteria_codes": "criteria", "critical_temp": "critical_temp", "critical_temp_high": "critical_temp_high", "critical_temp_low": "critical_temp_low", "critical_temp_mineral": "critical_temp_mineral", "critical_temp_type": "critical_temp_type", "specimen_density": "density", "specimen_description": "description", "specimen_dip": "dip", "specimen_alpha": "dir_alpha", "specimen_alpha95": "dir_alpha95", "specimen_comp_name": "dir_comp", "specimen_comp_nmb": "dir_comp", "specimen_dang": "dir_dang", "specimen_dec": "dir_dec", "specimen_inc": "dir_inc", "average_k": "dir_k", "tilt_k_ratio": "dir_k_ratio", "specimen_mad_anc": "dir_mad_anc", "specimen_mad": "dir_mad_free", "specimen_comp_n": "dir_n_comps", "specimen_n": "dir_n_measurements", "specimen_nrm": "dir_nrm_origin", "specimen_polarity": "dir_polarity", "average_r": "dir_r", "specimen_tilt_correction": "dir_tilt_correction", "magic_experiment_names": "experiments", "external_database_names": "external_database_ids", "external_database_ids": "external_database_ids", "specimen_class": "geologic_classes", "specimen_type": "geologic_types", "hysteresis_bcr_bc": "hyst_bcr_bc", "hysteresis_mr_ms": "hyst_mr_ms", "specimen_igsn": "igsn", "magic_instrument_codes": "instrument_codes", "specimen_int": "int_abs", "specimen_int_sigma": "int_abs_sigma", "specimen_int_sigma_perc": "int_abs_sigma_perc", "specimen_int_alpha": "int_alpha", "specimen_alpha_prime": "int_alpha_prime", "specimen_b": "int_b", "specimen_b_beta": "int_b_beta", "specimen_b_sigma": "int_b_sigma", "specimen_cdrat": "int_cdrat", "specimen_correction": "int_corr", "specimen_int_corr_anisotropy": "int_corr_aniso", "specimen_int_corr_cooling_rate": "int_corr_cooling_rate", "specimen_int_corr_nlt": "int_corr_nlt", "specimen_int_crm": "int_crm", "specimen_dac": "int_dac", "specimen_int_dang": "int_dang", "specimen_dck": "int_dck", "specimen_delta": "int_delta", "specimen_dpal": "int_dpal", "specimen_drat": "int_drat", "specimen_tail_drat": "int_drat_tail", "specimen_drats": "int_drats", "specimen_dt": "int_dt", "specimen_dtr": "int_dtr", "specimen_f": "int_f", "specimen_frac": "int_frac", "specimen_fvds": "int_fvds", "specimen_g": "int_g", "specimen_gamma": "int_gamma", "specimen_gmax": "int_gmax", "specimen_k": "int_k", "specimen_k_prime": "int_k_prime", "specimen_k_prime_sse": "int_k_prime_sse", "specimen_k_sse": "int_k_sse", "specimen_int_mad_anc": "int_mad_anc", "specimen_int_mad": "int_mad_free", "specimen_maxdev": "int_maxdev", "specimen_md": "int_md", "specimen_mdev": "int_mdev", "specimen_mdrat": "int_mdrat", "specimen_ac_n": "int_n_ac", "specimen_int_n": "int_n_measurements", "specimen_int_ptrm_n": "int_n_ptrm", "specimen_int_ptrm_tail_n": "int_n_ptrm_tail", "specimen_ptrm": "int_ptrm", "specimen_q": "int_q", "specimen_r_sq": "int_r2_corr", "specimen_coeff_det_sq": "int_r2_det", "specimen_int_rel": "int_rel", "specimen_int_rel_sigma": "int_rel_sigma", "specimen_int_rel_sigma_perc": "int_rel_sigma_perc", "specimen_rsc": "int_rsc", "specimen_scat": "int_scat", "specimen_theta": "int_theta", "specimen_lab_field_dc": "int_treat_dc_field", "specimen_viscosity_index": "int_viscosity_index", "specimen_w": "int_w", "specimen_z": "int_z", "specimen_z_md": "int_z_md", "specimen_lithology": "lithologies", "specimen_magn_mass": "magn_mass", "specimen_magn_moment": "magn_moment", "specimen_magn_volume": "magn_volume", "measurement_step_max": "meas_step_max", "measurement_step_min": "meas_step_min", "measurement_step_unit": "meas_step_unit", "magic_method_codes": "method_codes", "specimen_flag": "result_quality", "data_type": "result_type", "er_sample_name": "sample", "er_scientist_mail_names": "scientists", "specimen_shape": "shape", "specimen_size": "size", "magic_software_packages": "software_packages", "er_specimen_name": "specimen", "er_synthetic_name": "specimen", "er_specimen_alternatives": "specimen_alternatives", "specimen_lab_field_ac": "susc_lab_field_ac_high", "specimen_texture": "texture", "specimen_volume": "volume", "specimen_weight": "weight"}, "samples": {"sample_alteration": "alteration_grade", "sample_alteration_type": "alteration_type", "er_analyst_mail_names": "analysts", "anisotropy_f": "aniso_f", "anisotropy_ff": "aniso_ff", "anisotropy_fl": "aniso_fl", "anisotropy_ftest": "aniso_ftest", "anisotropy_ftest12": "aniso_ftest12", "anisotropy_ftest23": "aniso_ftest23", "anisotropy_l": "aniso_l", "anisotropy_ll": "aniso_ll", "anisotropy_p": "aniso_p", "anisotropy_percent": "aniso_perc", "anisotropy_pp": "aniso_pp", "anisotropy_t": "aniso_t", "tilt_correction": "aniso_tilt_correction", "anisotropy_total": "aniso_total", "anisotropy_type": "aniso_type", "anisotropy_t1": "aniso_v1", "anisotropy_t2": "aniso_v2", "anisotropy_t3": "aniso_v3", "anisotropy_vg": "aniso_vg", "sample_azimuth": "azimuth", "sample_declination_correction": "azimuth_dec_correction", "sample_bed_dip": "bed_dip", "sample_bed_dip_direction": "bed_dip_direction", "er_citation_names": "citations", "sample_cooling_rate": "cooling_rate", "pmag_criteria_codes": "criteria", "sample_description": "description", "sample_dip": "dip", "sample_alpha95": "dir_alpha95", "sample_comp_name": "dir_comp_name", "sample_comp_nmb": "dir_comp_name", "sample_dec": "dir_dec", "sample_inc": "dir_inc", "sample_k": "dir_k", "tilt_k_ratio": "dir_k_ratio", "sample_comp_n": "dir_n_comps", "average_nn": "dir_n_measurements", "sample_n": "dir_n_specimens", "sample_n_lines": "dir_n_specimens_lines", "sample_n_planes": "dir_n_specimens_planes", "sample_nrm": "dir_nrm_origin", "sample_polarity": "dir_polarity", "sample_r": "dir_r", "sample_tilt_correction": "dir_tilt_correction", "magic_experiment_names": "experiments", "external_database_names": "external_database_ids", "external_database_ids": "external_database_ids", "sample_class": "geologic_classes", "sample_type": "geologic_types", "sample_height": "height", "sample_igsn": "igsn", "magic_instrument_codes": "instrument_codes", "sample_int": "int_abs", "sample_int_sigma": "int_abs_sigma", "sample_int_sigma_perc": "int_abs_sigma_perc", "average_int_nn": "int_n_measurements", "sample_int_n": "int_n_specimens", "sample_int_rel": "int_rel", "sample_int_rel_sigma": "int_rel_sigma", "sample_int_rel_sigma_perc": "int_rel_sigma_perc", "sample_lat": "lat", "sample_location_precision": "lat_lon_precision", "average_lat_sigma": "lat_sigma", "sample_lithology": "lithologies", "sample_lon": "lon", "average_lon_sigma": "lon_sigma", "sample_magn_mass": "magn_mass", "sample_magn_volume": "magn_volume", "magic_method_codes": "method_codes", "sample_orientation_flag": "orientation_quality", "sample_flag": "result_quality", "data_type": "result_type", "er_sample_name": "sample", "er_sample_alternatives": "sample_alternatives", "er_scientist_mail_names": "scientists", "er_site_name": "site", "magic_software_packages": "software_packages", "er_specimen_names": "specimens", "er_synthetic_names": "specimens", "sample_texture": "texture", "sample_date": "timestamp", "sample_time_zone": "timestamp"}, "sites": {"site_inferred_age": "age", "site_inferred_age_high": "age_high", "site_inferred_age_low": "age_low", "site_inferred_age_sigma": "age_sigma", "site_inferred_age_unit": "age_unit", "er_analyst_mail_names": "analysts", "anisotropy_f": "aniso_f", "anisotropy_ff": "aniso_ff", "anisotropy_fl": "aniso_fl", "anisotropy_ftest": "aniso_ftest", "anisotropy_ftest12": "aniso_ftest12", "anisotropy_ftest23": "aniso_ftest23", "anisotropy_l": "aniso_l", "anisotropy_ll": "aniso_ll", "anisotropy_p": "aniso_p", "anisotropy_percent": "aniso_perc", "anisotropy_pp": "aniso_pp", "anisotropy_t": "aniso_t", "tilt_correction": "aniso_tilt_correction", "anisotropy_total": "aniso_total", "anisotropy_type": "aniso_type", "anisotropy_t1": "aniso_v1", "anisotropy_t2": "aniso_v2", "anisotropy_t3": "aniso_v3", "anisotropy_vg": "aniso_vg", "site_bed_dip": "bed_dip", "site_bed_dip_direction": "bed_dip_direction", "er_citation_names": "citations", "site_composite_depth": "composite_depth", "conglomerate_test": "conglomerate_test", "contact_test": "contact_test", "site_cooling_rate": "cooling_rate", "site_core_depth": "core_depth", "pmag_criteria_codes": "criteria", "site_description": "description", "site_alpha95": "dir_alpha95", "site_comp_name": "dir_comp_name", "site_comp_nmb": "dir_comp_name", "site_dec": "dir_dec", "site_inc": "dir_inc", "site_k": "dir_k", "tilt_k_ratio": "dir_k_ratio", "site_comp_n": "dir_n_comps", "site_n": "dir_n_samples", "site_n_lines": "dir_n_specimens_lines", "site_n_planes": "dir_n_specimens_planes", "site_n_total": "dir_n_total_samples", "site_nrm": "dir_nrm_origin", "site_polarity": "dir_polarity", "site_r": "dir_r", "site_tilt_correction": "dir_tilt_correction", "site_elevation": "elevation", "magic_experiment_names": "experiments", "external_database_names": "external_database_ids", "external_database_ids": "external_database_ids", "site_location_precision": "geographic_precision", "site_class": "geologic_classes", "site_type": "geologic_types", "site_height": "height", "site_igsn": "igsn", "magic_instrument_codes": "instrument_codes", "site_int": "int_abs", "site_int_sigma": "int_abs_sigma", "site_int_sigma_perc": "int_abs_sigma_perc", "site_int_n": "int_n_samples", "average_int_nn": "int_n_specimens", "site_int_rel": "int_rel", "site_int_rel_sigma": "int_rel_sigma", "site_int_rel_sigma_perc": "int_rel_sigma_perc", "site_lat": "lat", "average_lat_sigma": "lat_sigma", "site_lithology": "lithologies", "er_location_name": "location", "site_lon": "lon", "average_lon_sigma": "lon_sigma", "site_magn_mass": "magn_mass", "site_magn_volume": "magn_volume", "magic_method_codes": "method_codes", "model_lat": "paleolat", "model_lat_sigma": "paleolat_sigma", "model_lon": "paleolon", "model_lon_sigma": "paleolon_sigma", "site_flag": "result_quality", "data_type": "result_type", "er_sample_names": "samples", "er_scientist_mail_names": "scientists", "er_site_name": "site", "er_site_alternatives": "site_alternatives", "magic_software_packages": "software_packages", "er_specimen_names": "specimens", "er_synthetic_names": "specimens", "vadm": "vadm", "vadm_n": "vadm_n_samples", "vadm_sigma": "vadm_sigma", "vdm": "vdm", "vdm_n": "vdm_n_samples", "vdm_sigma": "vdm_sigma", "vgp_alpha95": "vgp_alpha95", "vgp_dm": "vgp_dm", "vgp_dp": "vgp_dp", "vgp_lat": "vgp_lat", "vgp_lon": "vgp_lon", "vgp_n": "vgp_n_samples"}, "locations": {"average_age": "age", "average_age_high": "age_high", "average_age_low": "age_low", "average_age_sigma": "age_sigma", "average_age_unit": "age_unit", "er_analyst_mail_names": "analysts", "er_citation_names": "citations", "conglomerate_test": "conglomerate_test", "contact_test": "contact_test", "continent_ocean": "continent_ocean", "country": "country", "pmag_criteria_codes": "criteria", "location_description": "description", "average_alpha95": "dir_alpha95", "average_dec": "dir_dec", "average_inc": "dir_inc", "average_k": "dir_k", "tilt_k_ratio": "dir_k_ratio", "average_nn": "dir_n_samples", "average_n": "dir_n_sites", "average_r": "dir_r", "tilt_correction": "dir_tilt_correction", "location_end_elevation": "elevation_high", "location_begin_elevation": "elevation_low", "location_url": "expedition_url", "magic_experiment_names": "experiments", "external_database_names": "external_database_ids", "fold_test": "fold_test", "fold_test_significance": "fold_test_significance", "location_class": "geologic_classes", "geological_province_section": "geological_province_sections", "average_int": "int_abs", "average_int_sigma": "int_abs_sigma", "average_int_sigma_perc": "int_abs_sigma_perc", "average_int_nn": "int_n_samples", "average_int_n": "int_n_sites", "location_precision": "lat_lon_precision", "location_begin_lat": "lat_s", "location_end_lat": "lat_s", "location_lithology": "lithologies", "er_location_name": "location", "er_location_alternatives": "location_alternatives", "location_type": "location_type", "location_begin_lon": "lon_w", "location_end_lon": "lon_w", "magic_method_codes": "method_codes", "ocean_sea": "ocean_sea", "vadm": "padm", "vadm_n": "padm_n_sites", "vadm_sigma": "padm_sigma", "model_lat": "paleolat", "model_lat_sigma": "paleolat_sigma", "model_lon": "paleolon", "model_lon_sigma": "paleolon_sigma", "vdm": "pdm", "vdm_n": "pdm_n_sites", "vdm_sigma": "pdm_sigma", "plate_block": "plate_blocks", "vgp_alpha95": "pole_alpha95", "antipodal": "pole_antipodal_angle", "pole_comp_name": "pole_comp_name", "zeta_semi_angle": "pole_conf", "vgp_dm": "pole_dm", "vgp_dp": "pole_dp", "vgp_lat": "pole_lat", "vgp_lon": "pole_lon", "vgp_n": "pole_n_sites", "percent_reversed": "pole_reversed_perc", "region": "region", "pmag_result_name": "result_name", "data_type": "result_type", "reversal_test": "reversal_test", "rock_magnetic_test": "rock_magnetic_test", "er_sample_names": "samples", "er_scientist_mail_names": "scientists", "er_site_names": "sites", "magic_software_packages": "software_packages", "er_specimen_names": "specimens", "tectonic_setting": "tectonic_settings", "terrane": "terranes", "village_city": "village_city"}, "ages": {"age": "age", "age_range_high": "age_high", "age_range_low": "age_low", "age_sigma": "age_sigma", "age_unit": "age_unit", "astronomical_stage": "astronomical_stage", "biostrat_zone": "biostrat_zone", "er_citation_names": "citations", "conodont_zone": "conodont_zone", "age_culture_name": "culture", "age_description": "description", "er_location_name": "location", "magnetic_reversal_chron": "magnetic_reversal_chron", "magic_method_codes": "method_codes", "oxygen_stage": "oxygen_stage", "er_sample_name": "sample", "er_site_name": "site", "er_specimen_name": "specimen", "tiepoint_name": "tiepoint", "tiepoint_alternatives": "tiepoint_alternatives", "tiepoint_elevation": "tiepoint_elevation", "tiepoint_height": "tiepoint_height", "tiepoint_height_sigma": "tiepoint_height_sigma", "tiepoint_type": "tiepoint_type", "er_timescale_citation_names": "timescale_citations", "timescale_eon": "timescale_eon", "timescale_epoch": "timescale_epoch", "timescale_era": "timescale_era", "timescale_period": "timescale_period", "timescale_stage": "timescale_stage"}, "measurements": {"er_analyst_mail_names": "analysts", "er_citation_names": "citations", "measurement_description": "description", "measurement_csd": "dir_csd", "measurement_dec": "dir_dec", "measurement_inc": "dir_inc", "magic_experiment_name": "experiment", "external_database_names": "external_database_ids", "external_database_ids": "external_database_ids", "measurement_charging_mode": "hyst_charging_mode", "measurement_loop_x": "hyst_loop", "measurement_sweep_rate": "hyst_sweep_rate", "magic_instrument_codes": "instrument_codes", "measurement_magn_mass": "magn_mass", "measurement_magn_moment": "magn_moment", "measurement_r2": "magn_r2_det", "measurement_magn_volume": "magn_volume", "measurement_sd_x": "magn_x_sigma", "measurement_sd": "magn_xyz_sigma", "measurement_sd_y": "magn_y_sigma", "measurement_sd_z": "magn_z_sigma", "measurement_freq": "meas_freq", "measurement_lab_field_ac": "meas_field_ac", "measurement_lab_field_dc": "meas_field_dc", "measurement_positions": "meas_n_orient", "measurement_orient_phi": "meas_orient_phi", "measurement_orient_theta": "meas_orient_theta", "measurement_pos_x": "meas_pos_x", "measurement_pos_y": "meas_pos_y", "measurement_pos_z": "meas_pos_z", "measurement_temp": "meas_temp", "measurement_temp_change": "meas_temp_change", "measurement_number": "measurement", "magic_method_codes": "method_codes", "measurement_flag": "quality", "magic_software_packages": "software_packages", "er_specimen_name": "specimen", "er_synthetic_name": "specimen", "measurement_standard": "standard", "measurement_chi_mass": "susc_chi_mass", "measurement_chi_qdr_mass": "susc_chi_qdr_mass", "measurement_chi_qdr_volume": "susc_chi_qdr_volume", "measurement_chi_volume": "susc_chi_volume", "measurement_date": "timestamp", "measurement_time_zone": "timestamp", "treatment_ac_field": "treat_ac_field", "treatment_ac_field_dc_off": "treat_ac_field_dc_off", "treatment_ac_field_dc_on": "treat_ac_field_dc_on", "treatment_ac_field_decay_rate": "treat_ac_field_decay_rate", "treatment_dc_field": "treat_dc_field", "treatment_dc_field_ac_off": "treat_dc_field_ac_off", "treatment_dc_field_ac_on": "treat_dc_field_ac_on", "treatment_dc_field_decay_rate": "treat_dc_field_decay_rate", "treatment_dc_field_phi": "treat_dc_field_phi", "treatment_dc_field_theta": "treat_dc_field_theta", "treatment_mw_energy": "treat_mw_energy", "treatment_mw_integral": "treat_mw_integral", "treatment_mw_power": "treat_mw_power", "treatment_mw_time": "treat_mw_time", "treatment_temp": "treat_temp", "treatment_temp_dc_off": "treat_temp_dc_off", "treatment_temp_dc_on": "treat_temp_dc_on", "treatment_temp_decay_rate": "treat_temp_decay_rate"}, "criteria": {"er_citation_names": "citations", "pmag_criteria_code": "criterion", "criteria_definition": "description"}, "contribution": {}, "images": {"er_citation_names": "citations", "image_description": "description", "er_image_alternatives": "description", "er_image_name": "file", "image_keywords": "keywords", "er_location_name": "location", "er_photographer_mail_names": "photographers", "er_sample_name": "sample", "er_site_name": "site", "er_specimen_name": "specimen", "er_synthetic_name": "specimen", "image_date": "timestamp", "image_time_zone": "timestamp", "image_title": "title", "image_type": "type"}}
